com.holonplatform.vaadin.components

## Interface Components.input

- Enclosing interface:
    Components

      public static interface Components.input

  `Input`, `PropertyInputGroup` and `PropertyInputForm` builders provider.

- - ### Method Summary

    All Methods Static Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `static BooleanInputBuilder` | `boolean_()` Gets a builder to create `Boolean` type `Input`s.
    `static DateInputBuilder` | `date()` Gets a builder to create `Date` type `Input`s.
    `static DateInputBuilder` | `date(boolean inline)` Gets a builder to create `Date` type `Input`s.
    `static DateInputBuilder` | `date(DateInputBuilder.Resolution resolution)` Gets a builder to create `Date` type `Input`s.
    `static DateInputBuilder` | `date(DateInputBuilder.Resolution resolution, boolean inline)` Gets a builder to create `Date` type `Input`s.
    `static <E extends Enum<E>> BaseSelectModeMultiSelectInputBuilder.OptionsModeMultiSelectInputBuilder<E>` | `enumMulti(Class<E> type)` Gets a builder to create a multiple selection `Input` with given `Enum` class as data source, using all enum constants as selection items and default `BaseSelectInputBuilder.RenderingMode.OPTIONS` rendering mode.
    `static <E extends Enum<E>> MultiSelectInputBuilder.GenericMultiSelectInputBuilder<E>` | `enumMulti(Class<E> type, BaseSelectInputBuilder.RenderingMode renderingMode)` Gets a builder to create a multiple selection `Input` with given `Enum` class as data source, using all enum constants as selection items.
    `static <E extends Enum<E>> BaseSelectModeSingleSelectInputBuilder.SelectModeSingleSelectInputBuilder<E>` | `enumSingle(Class<E> type)` Gets a builder to create a single selection `Input` with given `Enum` class as data source, using all enum constants as selection items and default `BaseSelectInputBuilder.RenderingMode.SELECT` rendering mode.
    `static <E extends Enum<E>> SingleSelectInputBuilder.GenericSingleSelectInputBuilder<E>` | `enumSingle(Class<E> type, BaseSelectInputBuilder.RenderingMode renderingMode)` Gets a builder to create a single selection `Input` with given `Enum` class as data source, using all enum constants as selection items.
    `static PropertyInputForm.PropertyInputFormBuilder<com.vaadin.ui.FormLayout>` | `form()` Gets a builder to create a `PropertyInputForm` using a `FormLayout` as layout component and a default `ComposableComponent.componentContainerComposer()` to compose the fields on layout.
    `static <C extends com.vaadin.ui.Component> PropertyInputForm.PropertyInputFormBuilder<C>` | `form(C content)` Gets a builder to create a `PropertyInputForm`.
    `static PropertyInputForm.PropertyInputFormBuilder<com.vaadin.ui.GridLayout>` | `formGrid()` Gets a builder to create a `PropertyInputForm` using a `VerticalLayout` as layout component and a default `ComposableComponent.componentContainerComposer()` to compose the fields on layout.
    `static PropertyInputForm.PropertyInputFormBuilder<com.vaadin.ui.HorizontalLayout>` | `formHorizontal()` Gets a builder to create a `PropertyInputForm` using a `HorizontalLayout` as layout component and a default `ComposableComponent.componentContainerComposer()` to compose the fields on layout.
    `static PropertyInputForm.PropertyInputFormBuilder<com.vaadin.ui.VerticalLayout>` | `formVertical()` Gets a builder to create a `PropertyInputForm` using a `VerticalLayout` as layout component and a default `ComposableComponent.componentContainerComposer()` to compose the fields on layout.
    `static TemporalInputBuilder.TemporalWithoutTimeFieldBuilder<LocalDate>` | `localDate()` Gets a builder to create `LocalDate` type `Input`s.
    `static TemporalInputBuilder.TemporalWithoutTimeFieldBuilder<LocalDate>` | `localDate(boolean inline)` Gets a builder to create `LocalDate` type `Input`s.
    `static TemporalInputBuilder.TemporalWithTimeFieldBuilder<LocalDateTime>` | `localDateTime()` Gets a builder to create `LocalDateTime` type `Input`s.
    `static TemporalInputBuilder.TemporalWithTimeFieldBuilder<LocalDateTime>` | `localDateTime(boolean inline)` Gets a builder to create `LocalDateTime` type `Input`s.
    `static <T> BaseSelectModeMultiSelectInputBuilder.OptionsModeMultiSelectInputBuilder<T>` | `multiSelect(Class<? extends T> type)` Gets a builder to create a multiple selection `Input` using default `BaseSelectInputBuilder.RenderingMode.OPTIONS`.
    `static <T> MultiSelectInputBuilder.GenericMultiSelectInputBuilder<T>` | `multiSelect(Class<? extends T> type, BaseSelectInputBuilder.RenderingMode renderingMode)` Gets a builder to create a multiple selection `Input`.
    `static <T> BaseSelectModeMultiPropertySelectInputBuilder.OptionsModeMultiPropertySelectInputBuilder<T>` | `multiSelect(com.holonplatform.core.property.Property<T> selectProperty)` Gets a builder to create a `MultiSelect` with a `PropertyBox` items data source with `Property` as item properties using default `BaseSelectInputBuilder.RenderingMode.OPTIONS`.
    `static <T> MultiPropertySelectInputBuilder.GenericMultiPropertySelectInputBuilder<T>` | `multiSelect(com.holonplatform.core.property.Property<T> selectProperty, BaseSelectInputBuilder.RenderingMode renderingMode)` Gets a builder to create a `MultiSelect` with a `PropertyBox` items data source with `Property` as item properties.
    `static <T> BaseSelectModeMultiSelectInputBuilder.SelectModeMultiSelectInputBuilder<T>` | `multiSelectList(Class<? extends T> type)` Gets a builder to create a multiple selection `Input` using `BaseSelectInputBuilder.RenderingMode.SELECT`.
    `static <T> BaseSelectModeMultiPropertySelectInputBuilder.SelectModeMultiPropertySelectInputBuilder<T>` | `multiSelectList(com.holonplatform.core.property.Property<T> selectProperty)` Gets a builder to create a `MultiSelect` with a `PropertyBox` items data source with `Property` as item properties using default `BaseSelectInputBuilder.RenderingMode.SELECT`.
    `static <T extends Number> NumberInputBuilder<T>` | `number(Class<T> numberClass)` Gets a builder to create `Number` type `Input`s.
    `static PropertyInputGroup.PropertyInputGroupBuilder` | `propertyGroup()` Gets a builder to create a `PropertyInputGroup`.
    `static SecretInputBuilder` | `secretString()` Gets a builder to create `String` type `Input`s which not display user input on screen, used to enter secret text information like passwords.
    `static <T> BaseSelectModeSingleSelectInputBuilder.NativeModeSingleSelectInputBuilder<T>` | `singleNativeSelect(Class<? extends T> type)` Gets a builder to create a single selection `Input` using `BaseSelectInputBuilder.RenderingMode.NATIVE_SELECT`.
    `static <T> BaseSelectModeSinglePropertySelectInputBuilder.NativeModeSinglePropertySelectInputBuilder<T>` | `singleNativeSelect(com.holonplatform.core.property.Property<T> selectProperty)` Gets a builder to create a `SingleSelect` with a `PropertyBox` items data source with `Property` as item properties using `BaseSelectInputBuilder.RenderingMode.NATIVE_SELECT`.
    `static <T> BaseSelectModeSingleSelectInputBuilder.OptionsModeSingleSelectInputBuilder<T>` | `singleOptionSelect(Class<? extends T> type)` Gets a builder to create a single selection `Input` using `BaseSelectInputBuilder.RenderingMode.OPTIONS`.
    `static <T> BaseSelectModeSinglePropertySelectInputBuilder.OptionsModeSinglePropertySelectInputBuilder<T>` | `singleOptionSelect(com.holonplatform.core.property.Property<T> selectProperty)` Gets a builder to create a `SingleSelect` with a `PropertyBox` items data source with `Property` as item properties using `BaseSelectInputBuilder.RenderingMode.OPTIONS`.
    `static <T> BaseSelectModeSingleSelectInputBuilder.SelectModeSingleSelectInputBuilder<T>` | `singleSelect(Class<? extends T> type)` Gets a builder to create a single selection `Input` using `BaseSelectInputBuilder.RenderingMode.SELECT`.
    `static <T> SingleSelectInputBuilder.GenericSingleSelectInputBuilder<T>` | `singleSelect(Class<? extends T> type, BaseSelectInputBuilder.RenderingMode renderingMode)` Gets a builder to create a single selection `Input`.
    `static <T> BaseSelectModeSinglePropertySelectInputBuilder.SelectModeSinglePropertySelectInputBuilder<T>` | `singleSelect(com.holonplatform.core.property.Property<T> selectProperty)` Gets a builder to create a `SingleSelect` with a `PropertyBox` items data source with `Property` as item properties using `BaseSelectInputBuilder.RenderingMode.SELECT`.
    `static <T> SinglePropertySelectInputBuilder.GenericSinglePropertySelectInputBuilder<T>` | `singleSelect(com.holonplatform.core.property.Property<T> selectProperty, BaseSelectInputBuilder.RenderingMode renderingMode)` Gets a builder to create a `SingleSelect` with a `PropertyBox` items data source with `Property` as item properties.
    `static StringInputBuilder` | `string()` Gets a builder to create `String` type `Input`s.
    `static StringInputBuilder` | `string(boolean area)` Gets a builder to create `String` type `Input`s.

- - ### Method Detail

    - #### string

          static StringInputBuilder string()

      Gets a builder to create `String` type `Input`s.
      Returns:
        Input builder

    - #### string

          static StringInputBuilder string(boolean area)

      Gets a builder to create `String` type `Input`s.
      Parameters:
        `area` - `true` to create an input component rendered as a text area, `false` for a standard text input
      Returns:
        Input builder

    - #### secretString

          static SecretInputBuilder secretString()

      Gets a builder to create `String` type `Input`s which not display user input on screen, used to enter secret text information like passwords.
      Returns:
        Input builder

    - #### number

          static <T extends Number> NumberInputBuilder<T> number(Class<T> numberClass)

      Gets a builder to create `Number` type `Input`s.
      Type Parameters:
        `T` - Number type
      Parameters:
        `numberClass` - Concrete number class
      Returns:
        Input builder

    - #### boolean_

          static BooleanInputBuilder boolean_()

      Gets a builder to create `Boolean` type `Input`s.
      Returns:
        Input builder

    - #### date

          static DateInputBuilder date(DateInputBuilder.Resolution resolution,
                                       boolean inline)

      Gets a builder to create `Date` type `Input`s.
      Parameters:
        `resolution` - field Resolution
        `inline` - `true` to render the input component using an inline calendar
      Returns:
        Input builder

    - #### date

          static DateInputBuilder date(DateInputBuilder.Resolution resolution)

      Gets a builder to create `Date` type `Input`s.
      Parameters:
        `resolution` - field Resolution
      Returns:
        Input builder

    - #### date

          static DateInputBuilder date(boolean inline)

      Gets a builder to create `Date` type `Input`s.
      Parameters:
        `inline` - `true` to render the input component using an inline calendar
      Returns:
        Input builder

    - #### date

          static DateInputBuilder date()

      Gets a builder to create `Date` type `Input`s.
      Returns:
        Input builder

    - #### localDate

          static TemporalInputBuilder.TemporalWithoutTimeFieldBuilder<LocalDate> localDate(boolean inline)

      Gets a builder to create `LocalDate` type `Input`s.
      Parameters:
        `inline` - `true` to render the input component using an inline calendar
      Returns:
        Input builder

    - #### localDate

          static TemporalInputBuilder.TemporalWithoutTimeFieldBuilder<LocalDate> localDate()

      Gets a builder to create `LocalDate` type `Input`s.
      Returns:
        Input builder

    - #### localDateTime

          static TemporalInputBuilder.TemporalWithTimeFieldBuilder<LocalDateTime> localDateTime(boolean inline)

      Gets a builder to create `LocalDateTime` type `Input`s.
      Parameters:
        `inline` - `true` to render the input component using an inline calendar
      Returns:
        Input builder

    - #### localDateTime

          static TemporalInputBuilder.TemporalWithTimeFieldBuilder<LocalDateTime> localDateTime()

      Gets a builder to create `LocalDateTime` type `Input`s.
      Returns:
        Input builder

    - #### singleSelect

          static <T> SingleSelectInputBuilder.GenericSingleSelectInputBuilder<T> singleSelect(Class<? extends T> type,
                                                                                              BaseSelectInputBuilder.RenderingMode renderingMode)

      Gets a builder to create a single selection `Input`.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `type` - Selection value type
        `renderingMode` - Rendering mode
      Returns:
        Input builder

    - #### singleSelect

          static <T> BaseSelectModeSingleSelectInputBuilder.SelectModeSingleSelectInputBuilder<T> singleSelect(Class<? extends T> type)

      Gets a builder to create a single selection `Input` using `BaseSelectInputBuilder.RenderingMode.SELECT`.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `type` - Selection value type
      Returns:
        Input builder

    - #### singleNativeSelect

          static <T> BaseSelectModeSingleSelectInputBuilder.NativeModeSingleSelectInputBuilder<T> singleNativeSelect(Class<? extends T> type)

      Gets a builder to create a single selection `Input` using `BaseSelectInputBuilder.RenderingMode.NATIVE_SELECT`.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `type` - Selection value type
      Returns:
        Input builder

    - #### singleOptionSelect

          static <T> BaseSelectModeSingleSelectInputBuilder.OptionsModeSingleSelectInputBuilder<T> singleOptionSelect(Class<? extends T> type)

      Gets a builder to create a single selection `Input` using `BaseSelectInputBuilder.RenderingMode.OPTIONS`.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `type` - Selection value type
      Returns:
        Input builder

    - #### singleSelect

          static <T> SinglePropertySelectInputBuilder.GenericSinglePropertySelectInputBuilder<T> singleSelect(com.holonplatform.core.property.Property<T> selectProperty,
                                                                                                              BaseSelectInputBuilder.RenderingMode renderingMode)

      Gets a builder to create a `SingleSelect` with a `PropertyBox` items data source with `Property` as item properties.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `selectProperty` - Property to select (not null)
        `renderingMode` - Rendering mode
      Returns:
        `SingleSelect` builder

    - #### singleSelect

          static <T> BaseSelectModeSinglePropertySelectInputBuilder.SelectModeSinglePropertySelectInputBuilder<T> singleSelect(com.holonplatform.core.property.Property<T> selectProperty)

      Gets a builder to create a `SingleSelect` with a `PropertyBox` items data source with `Property` as item properties using `BaseSelectInputBuilder.RenderingMode.SELECT`.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `selectProperty` - Property to select (not null)
      Returns:
        `SingleSelect` builder

    - #### singleNativeSelect

          static <T> BaseSelectModeSinglePropertySelectInputBuilder.NativeModeSinglePropertySelectInputBuilder<T> singleNativeSelect(com.holonplatform.core.property.Property<T> selectProperty)

      Gets a builder to create a `SingleSelect` with a `PropertyBox` items data source with `Property` as item properties using `BaseSelectInputBuilder.RenderingMode.NATIVE_SELECT`.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `selectProperty` - Property to select (not null)
      Returns:
        `SingleSelect` builder

    - #### singleOptionSelect

          static <T> BaseSelectModeSinglePropertySelectInputBuilder.OptionsModeSinglePropertySelectInputBuilder<T> singleOptionSelect(com.holonplatform.core.property.Property<T> selectProperty)

      Gets a builder to create a `SingleSelect` with a `PropertyBox` items data source with `Property` as item properties using `BaseSelectInputBuilder.RenderingMode.OPTIONS`.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `selectProperty` - Property to select (not null)
      Returns:
        `SingleSelect` builder

    - #### multiSelect

          static <T> MultiSelectInputBuilder.GenericMultiSelectInputBuilder<T> multiSelect(Class<? extends T> type,
                                                                                           BaseSelectInputBuilder.RenderingMode renderingMode)

      Gets a builder to create a multiple selection `Input`.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `type` - Selection value type
        `renderingMode` - Rendering mode
      Returns:
        Input builder

    - #### multiSelect

          static <T> BaseSelectModeMultiSelectInputBuilder.OptionsModeMultiSelectInputBuilder<T> multiSelect(Class<? extends T> type)

      Gets a builder to create a multiple selection `Input` using default `BaseSelectInputBuilder.RenderingMode.OPTIONS`.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `type` - Selection value type
      Returns:
        Input builder

    - #### multiSelectList

          static <T> BaseSelectModeMultiSelectInputBuilder.SelectModeMultiSelectInputBuilder<T> multiSelectList(Class<? extends T> type)

      Gets a builder to create a multiple selection `Input` using `BaseSelectInputBuilder.RenderingMode.SELECT`.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `type` - Selection value type
      Returns:
        Input builder

    - #### multiSelect

          static <T> MultiPropertySelectInputBuilder.GenericMultiPropertySelectInputBuilder<T> multiSelect(com.holonplatform.core.property.Property<T> selectProperty,
                                                                                                           BaseSelectInputBuilder.RenderingMode renderingMode)

      Gets a builder to create a `MultiSelect` with a `PropertyBox` items data source with `Property` as item properties.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `selectProperty` - Property to select (not null)
        `renderingMode` - Rendering mode
      Returns:
        `MultiSelect` builder

    - #### multiSelect

          static <T> BaseSelectModeMultiPropertySelectInputBuilder.OptionsModeMultiPropertySelectInputBuilder<T> multiSelect(com.holonplatform.core.property.Property<T> selectProperty)

      Gets a builder to create a `MultiSelect` with a `PropertyBox` items data source with `Property` as item properties using default `BaseSelectInputBuilder.RenderingMode.OPTIONS`.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `selectProperty` - Property to select (not null)
      Returns:
        `MultiSelect` builder

    - #### multiSelectList

          static <T> BaseSelectModeMultiPropertySelectInputBuilder.SelectModeMultiPropertySelectInputBuilder<T> multiSelectList(com.holonplatform.core.property.Property<T> selectProperty)

      Gets a builder to create a `MultiSelect` with a `PropertyBox` items data source with `Property` as item properties using default `BaseSelectInputBuilder.RenderingMode.SELECT`.
      Type Parameters:
        `T` - Selection value type
      Parameters:
        `selectProperty` - Property to select (not null)
      Returns:
        `MultiSelect` builder

    - #### enumSingle

          static <E extends Enum<E>> SingleSelectInputBuilder.GenericSingleSelectInputBuilder<E> enumSingle(Class<E> type,
                                                                                                            BaseSelectInputBuilder.RenderingMode renderingMode)

      Gets a builder to create a single selection `Input` with given `Enum` class as data source, using all enum constants as selection items.
      Type Parameters:
        `E` - Enum value type
      Parameters:
        `type` - Enum value type
        `renderingMode` - Rendering mode
      Returns:
        Input builder

    - #### enumSingle

          static <E extends Enum<E>> BaseSelectModeSingleSelectInputBuilder.SelectModeSingleSelectInputBuilder<E> enumSingle(Class<E> type)

      Gets a builder to create a single selection `Input` with given `Enum` class as data source, using all enum constants as selection items and default `BaseSelectInputBuilder.RenderingMode.SELECT` rendering mode.
      Type Parameters:
        `E` - Enum value type
      Parameters:
        `type` - Enum value type
      Returns:
        Input builder

    - #### enumMulti

          static <E extends Enum<E>> MultiSelectInputBuilder.GenericMultiSelectInputBuilder<E> enumMulti(Class<E> type,
                                                                                                         BaseSelectInputBuilder.RenderingMode renderingMode)

      Gets a builder to create a multiple selection `Input` with given `Enum` class as data source, using all enum constants as selection items.
      Type Parameters:
        `E` - Enum value type
      Parameters:
        `type` - Enum value type
        `renderingMode` - Rendering mode
      Returns:
        Input builder

    - #### enumMulti

          static <E extends Enum<E>> BaseSelectModeMultiSelectInputBuilder.OptionsModeMultiSelectInputBuilder<E> enumMulti(Class<E> type)

      Gets a builder to create a multiple selection `Input` with given `Enum` class as data source, using all enum constants as selection items and default `BaseSelectInputBuilder.RenderingMode.OPTIONS` rendering mode.
      Type Parameters:
        `E` - Enum value type
      Parameters:
        `type` - Enum value type
      Returns:
        Input builder

    - #### propertyGroup

          static PropertyInputGroup.PropertyInputGroupBuilder propertyGroup()

      Gets a builder to create a `PropertyInputGroup`.
      Returns:
        `PropertyInputGroup` builder

    - #### form

          static <C extends com.vaadin.ui.Component> PropertyInputForm.PropertyInputFormBuilder<C> form(C content)

      Gets a builder to create a `PropertyInputForm`.
      Type Parameters:
        `C` - Content type
      Parameters:
        `content` - Form content, where fields will be composed by the form `ComposableComponent.Composer` (not null)
      Returns:
        `PropertyInputForm` builder

    - #### form

          static PropertyInputForm.PropertyInputFormBuilder<com.vaadin.ui.FormLayout> form()

      Gets a builder to create a `PropertyInputForm` using a `FormLayout` as layout component and a default `ComposableComponent.componentContainerComposer()` to compose the fields on layout.
      Returns:
        `PropertyInputForm` builder

    - #### formVertical

          static PropertyInputForm.PropertyInputFormBuilder<com.vaadin.ui.VerticalLayout> formVertical()

      Gets a builder to create a `PropertyInputForm` using a `VerticalLayout` as layout component and a default `ComposableComponent.componentContainerComposer()` to compose the fields on layout.
      Returns:
        `PropertyInputForm` builder

    - #### formHorizontal

          static PropertyInputForm.PropertyInputFormBuilder<com.vaadin.ui.HorizontalLayout> formHorizontal()

      Gets a builder to create a `PropertyInputForm` using a `HorizontalLayout` as layout component and a default `ComposableComponent.componentContainerComposer()` to compose the fields on layout.
      Returns:
        `PropertyInputForm` builder

    - #### formGrid

          static PropertyInputForm.PropertyInputFormBuilder<com.vaadin.ui.GridLayout> formGrid()

      Gets a builder to create a `PropertyInputForm` using a `VerticalLayout` as layout component and a default `ComposableComponent.componentContainerComposer()` to compose the fields on layout.
      Returns:
        `PropertyInputForm` builder

Copyright © 2017 The Holon Platform. All rights reserved.